// 4islem.cs - Girilen matematiksel ifadenin sonuca ulaştırılması.
//
// Yazar:  Engin Kuzu <enginkuzu@gmail.com>
//
// Copyright (c) Engin KUZU.	3.11.2005	v0.0.1
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of version 2 of the Lesser GNU General 
// Public License as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.
//
// [ING] http://www.gnu.org/copyleft/gpl.html
//  [TR] http://www.belgeler.org/howto/gpl_copy.html

//	Uygulamanın Kabul Ettikleri
//	tamsayılar	parantezler	toplama	çıkarma	çarpma	bölme

using System;

class dort_islem
{
	static string yazi;		//klavyeden girilen matematiksel ifade
	static int[] sayilar;	//girilen karakter dizisindeki sabit sayıların tutulduğu dizi
	static int[] komutlar;	//girilen karakter dizisindeki ifadenin çözümlenmiş hali
	static int komutlar_sayac=0;	//komutlar dizisinin uzunluğu
	
	// Ana foksiyon
	public static void Main()
	{
		ifade_oku();
		hatali_girdi_var_mi();
		degiskenleri_olustur();
		degiskenlere_atama_yap();
		islemi_yap();
	}
	// Matematiksel ifadeyi okuyan fonsiyon
	public static void ifade_oku()
	{
		Console.Write("Bir matematiksel işlem giriniz : ");
		yazi=Console.ReadLine();
	}
	// Girdi hatalı ise hata mesajını gösteren bölüm
	public static void hatali_girdi_var_mi()
	{
		if ( denetle(yazi) == false )
		{
			Console.WriteLine("\nLütfen uygun karakterleri giriniz!");
			Console.WriteLine("İzin verilenler : Tamsayılar + - * / ve parantezler.");
			Environment.Exit(1);
		}
	}
	// Girilen karakterleri inceleyen bölüm
	public static bool denetle( string dizi)
	{
		foreach(char x in yazi)
		{
			if( x<58 && x>47 | x=='+' | x=='-' | x=='*' | x=='/' | x=='(' | x==')' )
				continue;
			else
				return false;
		}
		return true;
	}
	// Gerekli değişkenlerin oluşturulması
	public static void degiskenleri_olustur()
	{
		int i=yazi.Length;
		sayilar = new int[i];
		komutlar = new int[i];
	}
	// işlemin daha rahat yapılabileceği hale getirmek için gerekli çözümleme aşaması
	public static void degiskenlere_atama_yap()
	{
		int boy=yazi.Length;
		int i;
		for(i=0;i<boy;i++)
		{
			if(yazi[i] == '(')
			{
				komutlar[komutlar_sayac]=-1;
				komutlar_sayac++;
			}
			else if(yazi[i] == ')')
			{
				komutlar[komutlar_sayac]=-2;
				komutlar_sayac++;
			}
			else if(yazi[i] == '*')
			{
				komutlar[komutlar_sayac]=-3;
				komutlar_sayac++;
			}
			else if(yazi[i] == '/')
			{
				komutlar[komutlar_sayac]=-4;
				komutlar_sayac++;
			}
			else if(yazi[i] == '+')
			{
				komutlar[komutlar_sayac]=-5;
				komutlar_sayac++;
			}
			else if(yazi[i] == '-')
			{
				komutlar[komutlar_sayac]=-6;
				komutlar_sayac++;
			}
			else	// sabit bir sayının ayrıştırılıp diziye atanması
			{
				int cache=yazi[i]-48;
				i++;
				while(i<boy && (yazi[i]<58 && yazi[i]>47))
				{
					cache=cache*10+yazi[i]-48;
					i++;
				}
				i--;	
				sayilar[komutlar_sayac]=cache;
				komutlar[komutlar_sayac]=komutlar_sayac;
				komutlar_sayac++;
			}
		}
	}
	//işlemlerde matematiksel öncelikler dikkate alınmıştır.
	public static void islemi_yap()
	{
		int i;
		bool basadon=false;
		
		while(true)
		{
			basadon=false;
			
			for(i=1;i<komutlar_sayac-1;i++)
			{
				if(komutlar[i]==-3)	//çarpma
				{
					if(komutlar[i-1]>=0 && komutlar[i+1]>=0)
					{
						sayilar[komutlar[i-1]]*=sayilar[komutlar[i+1]];
						sil(i-1,2);	//i-1 den sonra gelen 2 elemanı sil.
						basadon=true;
						break;
					}
				}
			}
			if(basadon)
				continue;
			
			for(i=1;i<komutlar_sayac-1;i++)
			{
				if(komutlar[i]==-4)	//bölme
				{
					if(komutlar[i-1]>=0 && komutlar[i+1]>=0)
					{
						sayilar[komutlar[i-1]]/=sayilar[komutlar[i+1]];
						sil(i-1,2);
						basadon=true;
						break;
					}
				}
			}
			if(basadon)
				continue;
			
			for(i=1;i<komutlar_sayac-1;i++)
			{
				if(komutlar[i]==-5)	//toplama
				{
					if(komutlar[i-1]>=0 && komutlar[i+1]>=0)
					{
						sayilar[komutlar[i-1]]+=sayilar[komutlar[i+1]];
						sil(i-1,2);
						basadon=true;
						break;
					}
				}
			}
			if(basadon)
				continue;
			
			for(i=1;i<komutlar_sayac-1;i++)
			{
				if(komutlar[i]==-6)	//çıkarma
				{
					if(komutlar[i-1]>=0 && komutlar[i+1]>=0)
					{
						sayilar[komutlar[i-1]]-=sayilar[komutlar[i+1]];
						sil(i-1,2);
						basadon=true;
						break;
					}
				}
			}
			if(basadon)
				continue;
			
			for(i=0;i<komutlar_sayac-2;i++)
			{
				if(komutlar[i]==-1)	//parantez
				{
					if(komutlar[i+1]>=0 && komutlar[i+2]>=-2)
					{
						sil(i-1,1);
						sil(i,1);
						basadon=true;
						break;
					}
				}
			}
			if(basadon)
				continue;
			
			if(komutlar_sayac==1)
			{
				Console.WriteLine("Sonuç = {0}",sayilar[komutlar[0]]);
				Environment.Exit(0);
			}
			else	//İşleme devam edemiyor. Matematiksel ifadede bir hata var.
			{
				Console.WriteLine("\nSONLANMA : Girmiş olduğunuz matematiksel ifadede hata var.");
				Environment.Exit(1);
			}
		}
	}
	//komutlar dizisinden zamanı geldikçe silme yapar
	public static void sil(int yer,int k)
	{
		yer++;
		komutlar_sayac-=k;
		for(;yer<komutlar_sayac;yer++)
		{
			komutlar[yer]=komutlar[yer+k];
		}		
	}
}
